package com.kingdee.eas.custom.dormitorysystem.application.app;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectCollection;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemCollection;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.base.log.LogUtil;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonFacadeFactory;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.application.CheckInApplicationEntryCollection;
import com.kingdee.eas.custom.dormitorysystem.application.CheckInApplicationEntryInfo;
import com.kingdee.eas.custom.dormitorysystem.application.CheckInApplicationInfo;
import com.kingdee.eas.custom.dormitorysystem.occupants.IOccupants;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsFactory;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo;
import com.kingdee.eas.custom.dormitorysystem.otherbasicdata.PersonDormitoryTypeInfo;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.affair.AffairBizException;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.base.HRBaseException;
import com.kingdee.eas.hr.base.HRBillBaseInfo;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.eas.hr.emp.PersonPositionFactory;
import com.kingdee.eas.hr.emp.PersonPositionInfo;
import com.kingdee.shr.base.syssetting.BaseItemException;
import com.kingdee.shr.base.syssetting.BasicItemStateEnum;
import com.kingdee.shr.base.syssetting.IMSFServiceFacade;
import com.kingdee.shr.base.syssetting.MSFServiceFacadeFactory;
import com.kingdee.util.DateTimeUtils;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import java.util.*;

public class CheckInApplicationControllerBean extends AbstractCheckInApplicationControllerBean {
    private static Logger logger = Logger.getLogger(CheckInApplicationControllerBean.class);

    /**
     * ύЧ
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _submitEffect(Context ctx, String billId) throws BOSException, EASBizException {
        if (StringUtils.isEmpty(billId)) {
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"idΪ!"});
        }
        //У鵥
        CheckInApplicationInfo info = getCheckInApplicationInfo(ctx, new ObjectUuidPK(billId));
        HRBillStateEnum billState = info.getBillState();
        if (HRBillStateEnum.AUDITED.equals(billState)) {
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"Ѿͨظ"});
        }
        Map<String, String> params = new HashMap<String, String>();
        params.put("billIds", billId);
        Map result = null;
        try {
            IMSFServiceFacade imsfServiceFacade = MSFServiceFacadeFactory.getLocalInstance(ctx);
            result = (Map) imsfServiceFacade.processService("validateRoomAvailableByBillIdsService", params);
        } catch (Exception e) {
            logger.error(e);
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"ýӿvalidateRoomAvailableByBillIdsService: " + e.getMessage()});
        }
        int code = (int) result.get("code");
        if (500 == code) {
            List<String> errorMsgList = (List<String>) result.get("errorMsg");
            StringBuilder errorMsgBuilder = new StringBuilder();
            errorMsgList.stream().forEach(errorMsg -> {
                errorMsgBuilder.append(errorMsg).append("\n");
            });
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{errorMsgBuilder.toString()});
        }
        super._submitEffect(ctx, billId);
        //УסϢʱ佻
        //Уס뵥Ƿظύ
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        CheckInApplicationEntryCollection entrys = info.getEntrys();
        for (int i = 0; i < entrys.size(); i++) {
            CheckInApplicationEntryInfo entryInfo = entrys.get(i);
            PersonInfo personInfo = entryInfo.getPerson();
            String personId = personInfo.getId().toString();
            //УԱùϵ״̬
            IPerson iPerson = PersonFactory.getLocalInstance(ctx);
            //SelectorItemCollection sic = new SelectorItemCollection();
            //sic.add("");
            personInfo = iPerson.getPersonInfo(new ObjectUuidPK(personId));
//            boolean isInCount = personInfo.getEmployeeType().isIsInCount();
//            if (!isInCount) {
//                //Աùϵ״̬
//                //
//            }
            //סԱϢ
            //УʱǷڽ
            PersonPositionInfo pp = PersonPositionFactory.getLocalInstance(ctx).getPersonPositionInfo("select personDep.*,primaryPosition.* where person = '" + personId + "'");
            //סԱϢ
            OccupantsInfo occupantsInfo = new OccupantsInfo();
            //סԱ
            occupantsInfo.setPerson(personInfo);
            //ס
            occupantsInfo.setCheckInDate(entryInfo.getCheckInDate());
            //
            occupantsInfo.setCheckOutDate(entryInfo.getCheckoutDate());
            //ס
            occupantsInfo.setDormitory(entryInfo.getCheckInRoom());
            //Ա
            occupantsInfo.setPersonDormitoryType((PersonDormitoryTypeInfo) personInfo.get("personType"));
            occupantsInfo.setPersonPosition(pp);
            //״̬:
            occupantsInfo.setState(BasicItemStateEnum.ENABLE);
            iOccupants.addnew(occupantsInfo);
            entryInfo.setOccupants(occupantsInfo);
        }
        super._submitEffect(ctx, info);
        //
        update(ctx, new ObjectUuidPK(billId), info);
    }

    /**
     * ύЧ
     *
     * @param ctx
     * @param model
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _submitEffect(
            Context ctx,
            CoreBaseInfo model
    ) throws BOSException, EASBizException {
        //У鵥
        IObjectPK iObjectPK = super._submitEffect(ctx, model);
        CheckInApplicationInfo info = (CheckInApplicationInfo) model;
        String billId = info.getId().toString();
        //Date date = DateTimeUtils.parseDate("2199-12-31", "yyyy-MM-dd");


        CheckInApplicationEntryCollection entrys = info.getEntrys();
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        for (int i = 0; i < entrys.size(); i++) {
            CheckInApplicationEntryInfo entryInfo = entrys.get(i);
            PersonInfo personInfo = entryInfo.getPerson();
            String personId = personInfo.getId().toString();
            //УԱùϵ״̬
            IPerson iPerson = PersonFactory.getLocalInstance(ctx);
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("");
            sic.add("");
            sic.add("");


            personInfo = iPerson.getPersonInfo(new ObjectUuidPK(personId), sic);
            boolean isInCount = personInfo.getEmployeeType().isIsInCount();
            if (!isInCount) {
                //Աùϵ״̬

                //

            }
            //סԱϢ
            //УʱǷڽ
            //סԱϢ
            OccupantsInfo occupantsInfo = new OccupantsInfo();
            //סԱ
            occupantsInfo.setPerson(personInfo);
            //ס
            occupantsInfo.setCheckInDate(entryInfo.getCheckInDate());
            //
            // occupantsInfo.setCheckOutDate(date);
            //ס
            occupantsInfo.setDormitory(entryInfo.getCheckInRoom());
            //Ա
            //occupantsInfo.setPersonDormitoryType();
            //״̬:
            //occupantsInfo.setState(BasicItemStateEnum.ENABLE);
            iOccupants.addnew(occupantsInfo);
            entryInfo.setOccupants(occupantsInfo);
        }
        //
        update(ctx, new ObjectUuidPK(), info);

        return iObjectPK;
    }

    /**
     * 
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _untiCheckBizBill(
            Context ctx,
            String billId
    ) throws BOSException, EASBizException {
        //ûˮϸĿԷ
        //Ƿ
        //Ƿл
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        CheckInApplicationInfo info = getCheckInApplicationInfo(ctx, new ObjectUuidPK(billId), sic);
        HRBillStateEnum billState = info.getBillState();
        if (!HRBillStateEnum.AUDITED.equals(billState)) {
            throw new AffairBizException(HRBaseException.BILLSTATECANUNCHECK);
        }
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        Set<String> occupantsIds = new HashSet<>();
        CheckInApplicationEntryCollection entrys = info.getEntrys();
        for (int i = 0; i < entrys.size(); i++) {
            CheckInApplicationEntryInfo entryInfo = entrys.get(i);
            OccupantsInfo occupants = entryInfo.getOccupants();
            //У
            occupantsIds.add(occupants.getId().toString());
        }
        super._untiCheckBizBill(ctx, billId);
        if (!occupantsIds.isEmpty()) {
            iOccupants.delete("where id in (" + AtsUtil.convertSetToString(occupantsIds) + ")");
        }
    }
}