package com.kingdee.eas.custom.dormitorysystem.application.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.base.permission.UserInfo;
import com.kingdee.eas.basedata.org.HROrgUnitInfo;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.application.RoomChangeApplicationEntryCollection;
import com.kingdee.eas.custom.dormitorysystem.application.RoomChangeApplicationEntryInfo;
import com.kingdee.eas.custom.dormitorysystem.application.RoomChangeApplicationInfo;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.base.ApproveTypeEnum;
import com.kingdee.eas.hr.base.HRBillBaseInfo;
import com.kingdee.eas.hr.base.IHRBillBase;
import com.kingdee.eas.hr.emp.IPersonPosition;
import com.kingdee.eas.hr.emp.PersonPositionFactory;
import com.kingdee.eas.hr.emp.PersonPositionInfo;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.handler.EditHandler;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Timestamp;
import java.util.Date;

/**
 * @author qingwu
 * @date 2025/4/28
 * @apiNote
 */
public class RoomChangeApplicationBatchEditHandler extends EditHandler {
    private Context ctx = SHRContext.getInstance().getContext();
    private Logger logger = Logger.getLogger(this.getClass());

    @Override
    protected void verifyModel(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model) throws SHRWebException {
        super.verifyModel(request, response, model);
    }

    @Override
    protected void beforeSave(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model) throws SHRWebException {
        //super.beforeSave(request, response, model);
        RoomChangeApplicationInfo changeApplicationInfo = (RoomChangeApplicationInfo) model;
        HROrgUnitInfo hrOrgUnitInfo = new HROrgUnitInfo();
        hrOrgUnitInfo.setId(BOSUuid.read("00000000-0000-0000-0000-000000000000CCE7AED4"));
        changeApplicationInfo.setHrOrgUnit(hrOrgUnitInfo);
        changeApplicationInfo.setIsMultiEntry(true);
        //У
    }

    /**
     * ύЧ
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void submitEffectAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        CoreBaseInfo model = (CoreBaseInfo) request.getAttribute("dynamic_model");
        this.beforeSave(request, response, model);
        HRBillBaseInfo hrBillBaseInfo = (HRBillBaseInfo) model;
        hrBillBaseInfo.setApproveType(ApproveTypeEnum.DIRECT);
        try {
            IHRBillBase ihrBillBase = (IHRBillBase) this.getBizInterface();
            IObjectPK objectPK = ihrBillBase.submitEffect(model);
            model.setId(BOSUuid.read(objectPK.toString()));
        } catch (EASBizException var8) {
            logger.error(var8);
            throw new ShrWebBizException(var8.getMessage(), var8);
        } catch (BOSException var9) {
            logger.error(var9);
            throw new ShrWebBizException(var9.getMessage(), var9);
        } catch (Exception var10) {
            logger.error(var10);
            throw new ShrWebBizException(var10);
        }

        this.afterSave(request, response, model);
        this.saveAttachment(request, response, model);
        //this.reverseAttachment(request, response, model);
        this.writeSuccessData(model.getId().toString());
    }

    @Override
    protected void afterCreateNewModel(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo coreBaseInfo) throws SHRWebException {
        super.afterInitModel(request, response, coreBaseInfo);
        RoomChangeApplicationInfo roomChangeApplicationInfo = (RoomChangeApplicationInfo) coreBaseInfo;
        try {
            RoomChangeApplicationEntryCollection entrys = roomChangeApplicationInfo.getEntrys();
            RoomChangeApplicationEntryInfo roomChangeApplicationEntryInfo = new RoomChangeApplicationEntryInfo();
            //managementNotes  ˵
            StringBuilder managementNotes = new StringBuilder();
            managementNotes.append("Ը").append("\n");
            managementNotes.append("1Ծع˾ƶȡԱйع취˽Եʹλ").append("\n");
            managementNotes.append("2Ծάṫ𻵹Ծ⳥").append("\n");
            managementNotes.append("3ԾȫԼõˮ").append("\n");
            roomChangeApplicationInfo.setManagementNotes(managementNotes.toString());
            entrys.add(roomChangeApplicationEntryInfo);
            UserInfo user = ContextUtil.getCurrentUserInfo(ctx);
            roomChangeApplicationInfo.setCreator(user);
            roomChangeApplicationInfo.setCreateTime(new Timestamp(new Date().getTime()));
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        }
    }
}
