package com.kingdee.eas.custom.dormitorysystem.application.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.application.IRoomChangeApplication;
import com.kingdee.eas.custom.dormitorysystem.application.RoomChangeApplicationCollection;
import com.kingdee.eas.custom.dormitorysystem.application.RoomChangeApplicationFactory;
import com.kingdee.eas.custom.dormitorysystem.application.RoomChangeApplicationInfo;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.hr.ats.AtsOverTimeBillResEnum;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.ats.util.common.MLUtile;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * @author qingwu
 * @date 2025/4/28
 * @apiNote
 */
public class RoomChangeApplicationListHandler extends ListHandler {
    private Logger logger = Logger.getLogger(this.getClass());
    private Context ctx = SHRContext.getInstance().getContext();

    //@Override
    //public String deleteAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
    //    String billId = this.getBillId(request);
    //    FilterInfo fIlterInfo = new FilterInfo();
    //    FilterItemCollection filterItems = fIlterInfo.getFilterItems();
    //    filterItems.add(new FilterItemInfo("id", AtsUtil.toSet(billId), CompareType.INCLUDE));
    //    filterItems.add(new FilterItemInfo("billState", "0", CompareType.NOTEQUALS));
    //    EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(fIlterInfo, null, null);
    //
    //    CoreBaseCollection collection = new CoreBaseCollection();
    //
    //    IRoomChangeApplication iRoomChangeApplication = RoomChangeApplicationFactory.getLocalInstance(ctx);
    //    RoomChangeApplicationCollection roomChangeApplicationCollection = iRoomChangeApplication.getRoomChangeApplicationCollection(entityViewInfo);
    //    return super.deleteAction(request, response, modelMap);
    //}

    public String againstApproveAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException, BOSException, EASBizException, SQLException {
        Map<String, Object> res = new HashMap();
        Set<String> successIds = new HashSet();
        res.put("successIds", successIds);
        String billIds = this.getBillId(request);
        FilterInfo fIlterInfo = new FilterInfo();
        FilterItemCollection filterItems = fIlterInfo.getFilterItems();
        filterItems.add(new FilterItemInfo("id", AtsUtil.toSet(billIds), CompareType.INCLUDE));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(fIlterInfo, null, null);

        CoreBaseCollection collection = new CoreBaseCollection();

        IRoomChangeApplication iRoomChangeApplication = RoomChangeApplicationFactory.getLocalInstance(ctx);
        RoomChangeApplicationCollection roomChangeApplicationCollection = iRoomChangeApplication.getRoomChangeApplicationCollection(entityViewInfo);
        for (int i = 0; i < roomChangeApplicationCollection.size(); i++) {
            RoomChangeApplicationInfo roomChangeApplicationInfo = roomChangeApplicationCollection.get(i);
            successIds.add(roomChangeApplicationInfo.getId().toString());
            roomChangeApplicationInfo.setBillState(HRBillStateEnum.SAVED);
            collection.add(roomChangeApplicationInfo);
        }
        SelectorItemCollection sic  = new SelectorItemCollection();
        sic.add("billState");
        iRoomChangeApplication.updateBatchData(collection);
        res.put("msg", MLUtile.getRes(AtsOverTimeBillResEnum.againstApproveSuccess, this.ctx));
        JSONUtils.writeJson(response, res);
        return null;
    }

}
